# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from .. import utilities, tables

class Trigger(pulumi.CustomResource):
    build: pulumi.Output[dict]
    """
    A build resource in the Container Builder API.
    Structure is documented below. At a high
    level, a `build` describes where to find source code, how to build it (for
    example, the builder image to run on the source), and where to store
    the built artifacts. Fields can include the following variables, which
    will be expanded when the build is created:
    * `$PROJECT_ID`: the project ID of the build.
    * `$BUILD_ID`: the autogenerated ID of the build.
    * `$REPO_NAME`: the source repository name specified by RepoSource.
    * `$BRANCH_NAME`: the branch name specified by RepoSource.
    * `$TAG_NAME`: the tag name specified by RepoSource.
    * `$REVISION_ID` or `$COMMIT_SHA`: the commit SHA specified by RepoSource
    or resolved from the specified branch or tag.
    * `$SHORT_SHA`: first 7 characters of `$REVISION_ID` or `$COMMIT_SHA`.
    """
    description: pulumi.Output[str]
    """
    A brief description of this resource.
    """
    filename: pulumi.Output[str]
    """
    Specify the path to a Cloud Build configuration file
    in the Git repo. This is mutually exclusive with `build`. This is typically
    `cloudbuild.yaml` however it can be specified by the user.
    """
    project: pulumi.Output[str]
    """
    The ID of the project that the trigger will be created in.
    Defaults to the provider project configuration.
    """
    substitutions: pulumi.Output[dict]
    trigger_template: pulumi.Output[dict]
    """
    Location of the source in a Google
    Cloud Source Repository. Structure is documented below.
    """
    def __init__(__self__, resource_name, opts=None, build=None, description=None, filename=None, project=None, substitutions=None, trigger_template=None, __name__=None, __opts__=None):
        """
        Creates a new build trigger within GCR. For more information, see
        [the official documentation](https://cloud.google.com/container-builder/docs/running-builds/automate-builds)
        and
        [API](https://godoc.org/google.golang.org/api/cloudbuild/v1#BuildTrigger).
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] build: A build resource in the Container Builder API.
               Structure is documented below. At a high
               level, a `build` describes where to find source code, how to build it (for
               example, the builder image to run on the source), and where to store
               the built artifacts. Fields can include the following variables, which
               will be expanded when the build is created:
               * `$PROJECT_ID`: the project ID of the build.
               * `$BUILD_ID`: the autogenerated ID of the build.
               * `$REPO_NAME`: the source repository name specified by RepoSource.
               * `$BRANCH_NAME`: the branch name specified by RepoSource.
               * `$TAG_NAME`: the tag name specified by RepoSource.
               * `$REVISION_ID` or `$COMMIT_SHA`: the commit SHA specified by RepoSource
               or resolved from the specified branch or tag.
               * `$SHORT_SHA`: first 7 characters of `$REVISION_ID` or `$COMMIT_SHA`.
        :param pulumi.Input[str] description: A brief description of this resource.
        :param pulumi.Input[str] filename: Specify the path to a Cloud Build configuration file
               in the Git repo. This is mutually exclusive with `build`. This is typically
               `cloudbuild.yaml` however it can be specified by the user.
        :param pulumi.Input[str] project: The ID of the project that the trigger will be created in.
               Defaults to the provider project configuration.
        :param pulumi.Input[dict] trigger_template: Location of the source in a Google
               Cloud Source Repository. Structure is documented below.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['build'] = build

        __props__['description'] = description

        __props__['filename'] = filename

        __props__['project'] = project

        __props__['substitutions'] = substitutions

        __props__['trigger_template'] = trigger_template

        super(Trigger, __self__).__init__(
            'gcp:cloudbuild/trigger:Trigger',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

